#piwi 18.01.2011 
# s.a. http://www.robotrontechnik.de/html/forum/thwb/showtopic.php?threadid=3846

use integer;

die <<HELP unless @ARGV;
Aufruf: crc16 bin-file
berechnet CRC16-Prfsumme (wie Z9001)
HELP

open IN, "<$ARGV[0]";
binmode IN;

until (eof IN) {
	read IN, $buf, 2048; 
	print ++$n, '. Block ';
	crc16();
}
close IN;


sub crc16 {
	#Arrays von 2KiByte FFh
	$len = 2048;
	
	#CRC-CCITT (CRC-16) x16 + x12 + x5 + 1 
	$POLY = 0b_0001_0000_0010_0001; # das 17. Bit entfllt
	
	#Startwert
	$crc16 = 0xFFFF;
	$sum16 = 0;
	
	for ($i=0;$i<$len;$i++) {
		my $byte = ord(substr($buf,$i,1));
		
		$sum16 += $byte;
		$sum16 &= 0xFFFF;

		$byte = $byte * 0x100;
		for (0..7) # 8 Bits
		{
			if (($byte & 0x8000) ^ ($crc16 & 0x8000)) {
				$crc16 <<= 1;
				$crc16 ^= $POLY;
				$crc16 &= 0xFFFF;
			} else {
				$crc16 <<= 1;
				$crc16 &= 0xFFFF;
			}
			$byte <<= 1;
			$byte &= 0xFFFF;
		}
	}

	# ausgabe
	printf "CRC = %.4X, SUM = %.4X\n", $crc16, $sum16;
}
